<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CampaignSearchRow StructType
 * @subpackage Structs
 */
class CampaignSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CampaignSearchRowBasic
     */
    public $basic;
    /**
     * The campaignRecipientJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EntitySearchRowBasic
     */
    public $campaignRecipientJoin;
    /**
     * The fileJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\FileSearchRowBasic
     */
    public $fileJoin;
    /**
     * The messagesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchRowBasic
     */
    public $messagesJoin;
    /**
     * The originatingLeadJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OriginatingLeadSearchRowBasic
     */
    public $originatingLeadJoin;
    /**
     * The promotionCodeJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PromotionCodeSearchRowBasic
     */
    public $promotionCodeJoin;
    /**
     * The transactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchRowBasic
     */
    public $transactionJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $userJoin;
    /**
     * The userNotesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\NoteSearchRowBasic
     */
    public $userNotesJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchRowBasic[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for CampaignSearchRow
     * @uses CampaignSearchRow::setBasic()
     * @uses CampaignSearchRow::setCampaignRecipientJoin()
     * @uses CampaignSearchRow::setFileJoin()
     * @uses CampaignSearchRow::setMessagesJoin()
     * @uses CampaignSearchRow::setOriginatingLeadJoin()
     * @uses CampaignSearchRow::setPromotionCodeJoin()
     * @uses CampaignSearchRow::setTransactionJoin()
     * @uses CampaignSearchRow::setUserJoin()
     * @uses CampaignSearchRow::setUserNotesJoin()
     * @uses CampaignSearchRow::setCustomSearchJoin()
     * @param \StructType\CampaignSearchRowBasic $basic
     * @param \StructType\EntitySearchRowBasic $campaignRecipientJoin
     * @param \StructType\FileSearchRowBasic $fileJoin
     * @param \StructType\MessageSearchRowBasic $messagesJoin
     * @param \StructType\OriginatingLeadSearchRowBasic $originatingLeadJoin
     * @param \StructType\PromotionCodeSearchRowBasic $promotionCodeJoin
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     */
    public function __construct(\StructType\CampaignSearchRowBasic $basic = null, \StructType\EntitySearchRowBasic $campaignRecipientJoin = null, \StructType\FileSearchRowBasic $fileJoin = null, \StructType\MessageSearchRowBasic $messagesJoin = null, \StructType\OriginatingLeadSearchRowBasic $originatingLeadJoin = null, \StructType\PromotionCodeSearchRowBasic $promotionCodeJoin = null, \StructType\TransactionSearchRowBasic $transactionJoin = null, \StructType\EmployeeSearchRowBasic $userJoin = null, \StructType\NoteSearchRowBasic $userNotesJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setCampaignRecipientJoin($campaignRecipientJoin)
            ->setFileJoin($fileJoin)
            ->setMessagesJoin($messagesJoin)
            ->setOriginatingLeadJoin($originatingLeadJoin)
            ->setPromotionCodeJoin($promotionCodeJoin)
            ->setTransactionJoin($transactionJoin)
            ->setUserJoin($userJoin)
            ->setUserNotesJoin($userNotesJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\CampaignSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\CampaignSearchRowBasic $basic
     * @return \StructType\CampaignSearchRow
     */
    public function setBasic(\StructType\CampaignSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get campaignRecipientJoin value
     * @return \StructType\EntitySearchRowBasic|null
     */
    public function getCampaignRecipientJoin()
    {
        return $this->campaignRecipientJoin;
    }
    /**
     * Set campaignRecipientJoin value
     * @param \StructType\EntitySearchRowBasic $campaignRecipientJoin
     * @return \StructType\CampaignSearchRow
     */
    public function setCampaignRecipientJoin(\StructType\EntitySearchRowBasic $campaignRecipientJoin = null)
    {
        $this->campaignRecipientJoin = $campaignRecipientJoin;
        return $this;
    }
    /**
     * Get fileJoin value
     * @return \StructType\FileSearchRowBasic|null
     */
    public function getFileJoin()
    {
        return $this->fileJoin;
    }
    /**
     * Set fileJoin value
     * @param \StructType\FileSearchRowBasic $fileJoin
     * @return \StructType\CampaignSearchRow
     */
    public function setFileJoin(\StructType\FileSearchRowBasic $fileJoin = null)
    {
        $this->fileJoin = $fileJoin;
        return $this;
    }
    /**
     * Get messagesJoin value
     * @return \StructType\MessageSearchRowBasic|null
     */
    public function getMessagesJoin()
    {
        return $this->messagesJoin;
    }
    /**
     * Set messagesJoin value
     * @param \StructType\MessageSearchRowBasic $messagesJoin
     * @return \StructType\CampaignSearchRow
     */
    public function setMessagesJoin(\StructType\MessageSearchRowBasic $messagesJoin = null)
    {
        $this->messagesJoin = $messagesJoin;
        return $this;
    }
    /**
     * Get originatingLeadJoin value
     * @return \StructType\OriginatingLeadSearchRowBasic|null
     */
    public function getOriginatingLeadJoin()
    {
        return $this->originatingLeadJoin;
    }
    /**
     * Set originatingLeadJoin value
     * @param \StructType\OriginatingLeadSearchRowBasic $originatingLeadJoin
     * @return \StructType\CampaignSearchRow
     */
    public function setOriginatingLeadJoin(\StructType\OriginatingLeadSearchRowBasic $originatingLeadJoin = null)
    {
        $this->originatingLeadJoin = $originatingLeadJoin;
        return $this;
    }
    /**
     * Get promotionCodeJoin value
     * @return \StructType\PromotionCodeSearchRowBasic|null
     */
    public function getPromotionCodeJoin()
    {
        return $this->promotionCodeJoin;
    }
    /**
     * Set promotionCodeJoin value
     * @param \StructType\PromotionCodeSearchRowBasic $promotionCodeJoin
     * @return \StructType\CampaignSearchRow
     */
    public function setPromotionCodeJoin(\StructType\PromotionCodeSearchRowBasic $promotionCodeJoin = null)
    {
        $this->promotionCodeJoin = $promotionCodeJoin;
        return $this;
    }
    /**
     * Get transactionJoin value
     * @return \StructType\TransactionSearchRowBasic|null
     */
    public function getTransactionJoin()
    {
        return $this->transactionJoin;
    }
    /**
     * Set transactionJoin value
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @return \StructType\CampaignSearchRow
     */
    public function setTransactionJoin(\StructType\TransactionSearchRowBasic $transactionJoin = null)
    {
        $this->transactionJoin = $transactionJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @return \StructType\CampaignSearchRow
     */
    public function setUserJoin(\StructType\EmployeeSearchRowBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get userNotesJoin value
     * @return \StructType\NoteSearchRowBasic|null
     */
    public function getUserNotesJoin()
    {
        return $this->userNotesJoin;
    }
    /**
     * Set userNotesJoin value
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @return \StructType\CampaignSearchRow
     */
    public function setUserNotesJoin(\StructType\NoteSearchRowBasic $userNotesJoin = null)
    {
        $this->userNotesJoin = $userNotesJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchRowBasic[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $campaignSearchRowCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$campaignSearchRowCustomSearchJoinItem instanceof \StructType\CustomSearchRowBasic) {
                $invalidValues[] = is_object($campaignSearchRowCustomSearchJoinItem) ? get_class($campaignSearchRowCustomSearchJoinItem) : sprintf('%s(%s)', gettype($campaignSearchRowCustomSearchJoinItem), var_export($campaignSearchRowCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     * @return \StructType\CampaignSearchRow
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic $item
     * @return \StructType\CampaignSearchRow
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchRowBasic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchRowBasic) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
